#include "record.h"
//#include "list.h"
#include "trie.h"

#include <stdlib.h>
#include <stdio.h>
#include <readline/readline.h>

mode_t mode;

int main(){
  trie *cnt=new_trie();
  trie *ntc=new_trie();
  trie *tcn=new_trie();
  record *r;

  while(1){
    printf("\nPhonebook\nType your command\nA: Add number\nD: Delete number\nP: Prefix search\nQ: Quit\nS: Search\n");
    char *cmd=readline("Command> ");
    if(cmd==NULL) return 0;
    switch(cmd[0]){
    case 'a':
    case 'A':
      r=new_record_from_stdin();
      if(r==NULL){
	printf("Character '$' is reserved, please don't use it\n");
	continue;
      }
      mode=CNT;
      insert(cnt,r);
      mode=NTC;
      insert(ntc,r);
      mode=TCN;
      if(insert(tcn,r)==1) printf("This entry already exists!\n");
      break;
    case 'd':
    case 'D':
      r=new_record_from_stdin();
      mode=CNT;
      delete(cnt,r);
      mode=NTC;
      delete(ntc,r);
      mode=TCN;
      record *deleted=delete(tcn,r);
      if(deleted==NULL)
	printf("Entry not found!\n");
      else
	delete_record(deleted);
      
      delete_record(r);
      break;
    case 'p':
    case 'P':
      printf("Prefix search for the family name\n");
      char *prefix=readline("Type prefix: ");
      if(index(prefix,'$')!=NULL){
	printf("Character '$' is reserved, please don't use it\n");
	continue;
      }
      mode=CNT;
      print_prefix(cnt,prefix);
      free(prefix);
      break;
    case 's':
    case 'S':
      printf("Type search record; <enter> matches any term\n");
      r=new_record_from_stdin();
      if(r==NULL){
	printf("Character '$' is reserved, please don't use it\n");
	continue;
      }
      
      //determines which trie to use based on which fields are empty
      int mask=0;
      if(r->familyname[0]!='\0') mask+=4;
      if(r->firstname[0]!='\0') mask+=2;
      if(r->number[0]!='\0') mask+=1;

      //XXX: mask=7
      //this can be optimized a bit, but we don't care since it is no bottleneck
      char *s=malloc(r->firstname_size+r->familyname_size+r->number_size+3);
      switch(mask){
      case 0: 
	mode=CNT;
	print_all(cnt);
	break;
      case 6:
      case 4:
	mode=CNT;
	strcpy(s,r->familyname);
	strcat(s,"$");
	if(mask==6){
	  strcat(s,r->firstname);
	  strcat(s,"$");
	}
	print_prefix(cnt,s);
	break;
      case 3:
      case 2:
	mode=NTC;
	strcpy(s,r->firstname);
	strcat(s,"$");
	if(mask==3){
	  strcat(s,r->number);
	  strcat(s,"$");
	}
	print_prefix(ntc,s);
	break;
      case 5:
      case 1:
	mode=TCN;
	strcpy(s,r->number);
	strcat(s,"$");
	if(mask==5){
	  strcat(s,r->familyname);
	  strcat(s,"$");
	}
	print_prefix(tcn,s);
	break;
      case 7:
	mode=CNT;
	strcpy(s,r->familyname);
	strcat(s,"$");
	strcat(s,r->firstname);
	strcat(s,"$");
	strcat(s,r->number);
	record *result=lookup(cnt,s);
	if(result!=NULL) print_record(result);
	break;
      }
      delete_record(r);
      break;
    case 'q':
    case 'Q':
      printf("Goodbye.\n");
      return 0;
    default:
      printf("Unknown command: '%c'\n",cmd[0]);
    }
  }
  return 0;
}

