#include "record.h"
#include "trie.h"

#include <stdlib.h>
#include <stdio.h>
#include <readline/readline.h>

void print_record(const record *r){
  printf("* First name: %20s Last name: %20s Number %20s\n",r->firstname,r->familyname,r->number);
}

record *new_record_from_stdin(){
  record *r=calloc(1,sizeof(record));
  r->firstname=readline("First name? ");
  r->firstname_size=strlen(r->firstname);
  if(index(r->firstname,'$')!=NULL) return NULL;
  r->familyname=readline("Family name? ");
  r->familyname_size=strlen(r->familyname);
  if(index(r->familyname,'$')!=NULL) return NULL;
  r->number=readline("Phone number?");
  r->number_size=strlen(r->number);
  if(index(r->number,'$')!=NULL) return NULL;
  return r;
};

void delete_record(record *r){
  free(r->firstname);
  free(r->familyname);
  free(r->number);
  free(r);
}
